<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_AlternateReceiptField ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_AlternateReceiptField extends AbstractStructArrayBase
{
    /**
     * The UserField
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_AlternateReceiptField[]
     */
    public $UserField;
    /**
     * Constructor method for ArrayOfJP_AlternateReceiptField
     * @uses ArrayOfJP_AlternateReceiptField::setUserField()
     * @param \StructType\JP_AlternateReceiptField[] $userField
     */
    public function __construct(array $userField = array())
    {
        $this
            ->setUserField($userField);
    }
    /**
     * Get UserField value
     * @return \StructType\JP_AlternateReceiptField[]|null
     */
    public function getUserField()
    {
        return $this->UserField;
    }
    /**
     * Set UserField value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_AlternateReceiptField[] $userField
     * @return \ArrayType\ArrayOfJP_AlternateReceiptField
     */
    public function setUserField(array $userField = array())
    {
        foreach ($userField as $arrayOfJP_AlternateReceiptFieldUserFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_AlternateReceiptFieldUserFieldItem instanceof \StructType\JP_AlternateReceiptField) {
                throw new \InvalidArgumentException(sprintf('The UserField property can only contain items of \StructType\JP_AlternateReceiptField, "%s" given', is_object($arrayOfJP_AlternateReceiptFieldUserFieldItem) ? get_class($arrayOfJP_AlternateReceiptFieldUserFieldItem) : gettype($arrayOfJP_AlternateReceiptFieldUserFieldItem)), __LINE__);
            }
        }
        $this->UserField = $userField;
        return $this;
    }
    /**
     * Add item to UserField value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_AlternateReceiptField $item
     * @return \ArrayType\ArrayOfJP_AlternateReceiptField
     */
    public function addToUserField(\StructType\JP_AlternateReceiptField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_AlternateReceiptField) {
            throw new \InvalidArgumentException(sprintf('The UserField property can only contain items of \StructType\JP_AlternateReceiptField, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UserField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_AlternateReceiptField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_AlternateReceiptField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_AlternateReceiptField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_AlternateReceiptField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_AlternateReceiptField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UserField
     */
    public function getAttributeName()
    {
        return 'UserField';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_AlternateReceiptField
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
